# Idioms

[Idioms](https://en.wikipedia.org/wiki/Programming_idiom) are commonly used
styles, guidelines and patterns largely agreed upon by a community.
Writing idiomatic code allows other developers to understand better what is
happening.

After all, the computer only cares about the machine code that is generated
by the compiler.
Instead, the source code is mainly beneficial to the developer.
So, since we have this abstraction layer, why not make it more readable?

Remember the [KISS principle](https://en.wikipedia.org/wiki/KISS_principle):
"Keep It Simple, Stupid". It claims that "most systems work best if they are
kept simple rather than made complicated; therefore, simplicity should be a key
goal in design, and unnecessary complexity should be avoided".

> Code is there for humans, not computers, to understand.
